#========================================================================================
#========================================================================================
#====================== ONLY TRIGGERED AS PARENT-CHILD PIPELINE =========================
#========================================================================================
#======== https://docs.gitlab.com/ee/ci/pipelines/parent_child_pipelines.html ===========
#========================================================================================
#========================================================================================


include:
  - local: "/ci-templates/extensions/.gitlab-ci-anchors.yml"
  - project: '$CI_PROJECT_NAMESPACE/gitlab-ci-templates'
    ref: master
    file: 'extensions/.gitlab-ci-checkUrlAvailability.yml'


variables:
  GITLAB_ENV_NAME: staging
  ENVIRONMENT: staging

  PROJECT_ID:  $CI_PROJECT_ID
  PROJECT_NAME: $CI_PROJECT_NAME
  REMOTE_STATE_ENV_DIR: staging
  #----> ACTION  ("destroy" | "deploy")




## ------------------------------------------------ STAGING CLUSTER----------------------------------------------


staging-deploy-cluster:
  stage: deploy
  extends: .staging:aws_cluster:deploy
  environment:
    name: staging
    on_stop: "staging-destroy-cluster"
    url: http://$ENV_URL
  rules:
    - if: $ACTION == "deploy"

check_url_availability:
  stage: deploy
  extends: .check-url-availability
  variables:
    CHECK_TIMEOUT: 600
    BASE_URL: $ENV_URL
  needs:
    - job: staging-deploy-cluster
      optional: true
      artifacts: true
  rules:
    - if: $ACTION == "deploy"

staging-destroy-cluster:
  stage: deploy
  extends: .staging:aws_cluster:destroy
  timeout: 5m
  environment:
    name: staging
    action: stop
  rules:
    - if: $ACTION == "deploy"
      when: manual
    - if: $ACTION == "destroy"
      when: always
